//
// Created by martin on 12.11.21.
//

#ifndef ANIMTESTBED_BLENDNODE_H
#define ANIMTESTBED_BLENDNODE_H

#include "AnimNode.h"

struct BlendNode : public AnimNode {
  BlendNode(AnimationController* animation_controller);
  virtual ~BlendNode() {}

  AnimNode* m_input_A;
  AnimNode* m_input_B;
  float m_weight;

  ozz::vector<ozz::math::SoaTransform> m_local_matrices_A;
  ozz::vector<ozz::math::SoaTransform> m_local_matrices_B;

  virtual void Reset() {
    m_current_time = 0.f;
  }

  virtual void Update(float dt) {
    m_input_A->Update(dt);
    m_input_B->Update(dt);
  }

  virtual void Evaluate(
      ozz::vector<ozz::math::SoaTransform>* local_matrices) override;

  virtual void DrawDebugUi();
};

#endif  //ANIMTESTBED_BLENDNODE_H
